'Radio SI4735, FM Radio
'Ref-Clock OC0A/ PD6
'Start at 88,8 MHz
'S1 short = Suchen +
'S1 long = search -
'S3 = vol -
'S3 = vol +

$regfile = "m88def.dat"
$baud = 19200
$crystal = 16000000
$hwstack = 16
$swstack = 32
$framesize = 32


Dim Ref As Word
Dim Am As Byte
Dim Ffm As Word
Dim Fam As Word
Dim T As Word
Dim T2 As Word
Dim Freq As Word
Dim Rssi As Word
Dim Snr As Word
Dim C As Word
Dim H As Byte
Dim L As Byte
Dim Vol As Byte
Dim Status As Byte
Dim R1 As Byte
Dim R2 As Byte
Dim R3 As Byte
Dim R4 As Byte
Dim R5 As Byte
Dim R6 As Byte
Dim R7 As Byte
Dim R8 As Byte
Dim R9 As Byte
Dim R10 As Byte
Dim R11 As Byte
Dim R12 As Byte
Dim R13 As Byte
Dim Bled As Byte
Dim Service As Byte
Dim Pos As Byte
Dim Ch As String * 1
Dim Tx As String * 2
Dim Utcoffset As Byte
Dim Minuten As Byte
Dim Stunden As Byte
Dim Lo As Byte
Dim Hi As Byte
Dim Nr As Word


Dim Rs As Byte
Dim Dat As Byte
Dim Mask As Byte
Dim N As Byte
Dim I As Byte
Dim J As Byte
Dim D As Byte
Dim Value As Integer
Dim State As Byte
Dim Nibble As Byte
Dim Low_nibble As Byte
Dim High_nibble As Byte
Dim Lcdbyte As Byte
Dim Lcdpos As Byte
Dim Lcdline As Byte
Dim Lcdtext As String * 20
Dim Text As String * 10
Dim Char As String * 1


Declare Sub Get_int_status()
Declare Sub Refclock()
Declare Sub Rx_volume()
Declare Sub Power_down();
Declare Sub Init_am()
Declare Sub Init_fm()
Declare Sub Am_tune_freq();
Declare Sub Fm_tune_freq();
Declare Sub Fm_seek_freq_up()
Declare Sub Fm_seek_freq_down()
Declare Sub Am_seek_freq_up()
Declare Sub Am_seek_freq_down()
Declare Sub Fm_tune_status()
Declare Sub Fm_rsq_status()
Declare Sub Am_tune_status()
Declare Sub Am_rsq_status()
Declare Sub Fm_start()
Declare Sub Am_start()
Declare Sub Am_seek_step_5khz()
Declare Sub Init_rds()
Declare Sub Fm_rds_status()
Declare Sub Rds()

Declare Sub Do1clock
Declare Sub Lcd_write_nibble
Declare Sub Lcd_write_byte
Declare Sub Lcd_pos
Declare Sub Lcd_text
Declare Sub Lcd_init


Config Timer0 = Pwm , Prescale = 1 , Compare A Pwm = Clear Down
Start Timer0
Pwm0a = 128                                                 'Xtal/2/(255) = 31373 Hz OC0A/ PD6

Portb = 255
Ddrb.1 = 1
Ddrb.2 = 1

Ffm = 8880                                                  'Start freq  FM *10 kHz
Fam = 6075                                                  'Startfreq   AM kHz
Vol = 63                                                    'Volume 0...63


Config Scl = Portd.5
Config Sda = Portd.7
I2cinit


Pe_clock Alias Portb.1
Pe_data Alias Portb.2


S1 Alias Pinb.0                                             'switches
S2 Alias Pinb.3
S3 Alias Pinb.4
Portb.0 = 1                                                 'Pullups s1...,s3
Portb.3 = 1
Portb.4 = 1


Lcd_init

Lcdpos = 2 : Lcdline = 1 : Lcd_pos
Lcdtext = "Elektor-CC2-" : Lcd_text
Lcdpos = 2 : Lcdline = 2 : Lcd_pos
Lcdtext = "DSP Radio" : Lcd_text

Ddrd.4 = 1                                                  'Reset SI4735
Waitms 500
Ddrd.4 = 0
Waitms 500

Lcdpos = 2 : Lcdline = 1 : Lcd_pos
Lcdtext = "               " : Lcd_text
Lcdpos = 2 : Lcdline = 2 : Lcd_pos
Lcdtext = "               " : Lcd_text

  Fm_start

  Do
    Waitms 1
    T = T + 1
    If T = 1000 Then T = 0
    If T = 500 Then
       Rds
       Fm_rsq_status
    End If
    If S1 = 0 Then
        T2 = 0
        Waitms 5
        Do
          Waitms 1
          T2 = T2 + 1
        Loop Until S1 = 1
        If T2 < 200 Then                                    'T1 short
          Fm_seek_freq_up
        Else                                                'T1 long
          Fm_seek_freq_down
        End If
        Waitms 500
        Fm_tune_status
    End If

    If S2 = 0 Then                                          'S3: vol -
        Vol = Vol - 1
        If Vol < 10 Then Vol = 10
        Waitms 50
        Rx_volume
    End If

    If S3 = 0 Then                                          'S4: vol +
        Vol = Vol + 1
        If Vol > 63 Then Vol = 63
        Waitms 50
        Rx_volume
    End If
  Loop


'  *** SI4735 ****

Sub Fm_start()
  Init_fm
  Waitms 200
  Refclock
  Waitms 5
  Rx_volume
  Waitms 5
  Fm_tune_freq
  Waitms 500
  Fm_tune_status
  Waitms 5
  Init_rds
End Sub

Sub Am_start()
  Init_am
  Waitms 200
  Refclock
  Waitms 5
  Rx_volume
  Waitms 5
  Am_tune_freq
  Waitms 500
  Am_seek_step_5khz
  Waitms 1
  Am_tune_status
End Sub

Sub Get_int_status()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H14
  I2cstop
  I2cstart
  I2cwbyte 35
  I2crbyte Status , Nack
  I2cstop
  Status = Status And 128
  Shift Status , Right , 7
End Sub

Sub Refclock()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H12
  I2cwbyte &H00
  I2cwbyte &H02
  I2cwbyte &H01
  Ref = 31373
  H = High(ref)
  L = Low(ref)
  I2cwbyte H
  I2cwbyte L
  I2cstop
End Sub


Sub Rx_volume()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H12
  I2cwbyte &H00
  I2cwbyte &H40
  I2cwbyte &H00
  I2cwbyte &H00
  I2cwbyte Vol
  I2cstop
End Sub

Sub Am_seek_step_5khz()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H12
  I2cwbyte &H00
  I2cwbyte &H34
  I2cwbyte &H02
  I2cwbyte &H00
  I2cwbyte &H05
  I2cstop
End Sub

Sub Power_down();
  I2cstart
  I2cwbyte 34
  I2cwbyte &H11
  I2cstop
End Sub

Sub Init_am()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H01
  I2cwbyte &H01
  I2cwbyte &H05
  I2cstop
End Sub

Sub Init_fm()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H01
  I2cwbyte &H00
  I2cwbyte &H05
  I2cstop
End Sub

Sub Am_tune_freq();
  I2cstart
  I2cwbyte 34
  I2cwbyte &H40
  I2cwbyte &H00
  H = High(fam)
  L = Low(fam)
  I2cwbyte H
  I2cwbyte L
  I2cwbyte &H00
  I2cstop
End Sub

Sub Fm_tune_freq();
  I2cstart
  I2cwbyte 34
  I2cwbyte &H20
  I2cwbyte &H00
  H = High(ffm)
  L = Low(ffm)
  I2cwbyte H
  I2cwbyte L
  I2cwbyte &H00
  I2cstop
End Sub

Sub Fm_seek_freq_up()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H21
  I2cwbyte &H0C
  I2cstop
End Sub


Sub Fm_seek_freq_down()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H21
  I2cwbyte &H04
  I2cstop
End Sub


Sub Am_seek_freq_up()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H41
  I2cwbyte &H0C
  I2cstop
End Sub


Sub Am_seek_freq_down()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H41
  I2cwbyte &H04
  I2cstop
End Sub



Sub Fm_tune_status()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H22
  I2cwbyte &H3
  I2cstop
  I2cstart
  I2cwbyte 35
  I2crbyte Status , Ack
  I2crbyte R1 , Ack
  I2crbyte R2 , Ack
  I2crbyte R3 , Ack
  I2crbyte R4 , Ack
  I2crbyte R5 , Ack
  I2crbyte R6 , Ack
  I2crbyte R7 , Nack
  I2cstop
  Freq = 256 * R2
  Freq = Freq + R3
  Rssi = R4
  Snr = R5
  Lcdpos = 2 : Lcdline = 1 : Lcd_pos
  Lcdtext = Str(freq) + " " : Lcd_text
  Lcdpos = 8 : Lcdline = 1 : Lcd_pos
  Lcdtext = Str(rssi) + " " : Lcd_text
  Lcdpos = 12 : Lcdline = 1 : Lcd_pos
  Lcdtext = Str(snr ) + " " : Lcd_text
End Sub

Sub Fm_rsq_status()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H23
  I2cwbyte &H00
  I2cstop
  I2cstart
  I2cwbyte 35
  I2crbyte Status , Ack
  I2crbyte R1 , Ack
  I2crbyte R2 , Ack
  I2crbyte R3 , Ack
  I2crbyte R4 , Ack
  I2crbyte R5 , Ack
  I2crbyte R6 , Ack
  I2crbyte R7 , Nack
  I2cstop
  Rssi = R4
  Snr = R5
  Lcdpos = 8 : Lcdline = 1 : Lcd_pos
  Lcdtext = Str(rssi) + " " : Lcd_text
  Lcdpos = 12 : Lcdline = 1 : Lcd_pos
  Lcdtext = Str(snr ) + " " : Lcd_text
End Sub

Sub Am_tune_status()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H42
  I2cwbyte &H01
  I2cstop
  I2cstart
  I2cwbyte 35
  I2crbyte Status , Ack
  I2crbyte R1 , Ack
  I2crbyte R2 , Ack
  I2crbyte R3 , Ack
  I2crbyte R4 , Ack
  I2crbyte R5 , Ack
  I2crbyte R6 , Ack
  I2crbyte R7 , Nack
  Freq = 256 * R2
  Freq = Freq + R3
  Rssi = R4
  Snr = R5
  C = 256 * R6
  C = C + R7
  I2cstop
  Lcdpos = 2 : Lcdline = 3 : Lcd_pos
  Lcdtext = Str(freq) + " " : Lcd_text
  Lcdpos = 8 : Lcdline = 3 : Lcd_pos
  Lcdtext = Str(rssi) + " " : Lcd_text
  Lcdpos = 12 : Lcdline = 3 : Lcd_pos
  Lcdtext = Str(snr ) + " " : Lcd_text
End Sub

Sub Am_rsq_status()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H43
  I2cwbyte &H00
  I2cstop
  I2cstart
  I2cwbyte 35
  I2crbyte Status , Ack
  I2crbyte R1 , Ack
  I2crbyte R2 , Ack
  I2crbyte R3 , Ack
  I2crbyte R4 , Ack
  I2crbyte R5 , Ack
  I2crbyte R6 , Ack
  I2crbyte R7 , Nack
  I2cstop
  Rssi = R4
  Snr = R5
  Lcdpos = 8 : Lcdline = 3 : Lcd_pos
  Lcdtext = Str(rssi) + " " : Lcd_text
  Lcdpos = 12 : Lcdline = 3 : Lcd_pos
  Lcdtext = Str(snr ) + " " : Lcd_text
End Sub



'   *** LCD ****

Sub Do1clock
  Waitus 50
  Pe_clock = 1
  Waitus 50
  Pe_clock = 0
  Waitus 50
End Sub


Sub Lcd_write_nibble
  Pe_clock = 0
  Pe_data = 0
  'Clear all stages of shift register
  For N = 1 To 8
    Do1clock
  Next N
  'Set E-Level for at Q7
  Pe_data = 1
  Do1clock
  'Set level for RS at Q6
  Pe_data = Rs
  Do1clock
  'Shift in 4 bits
  Mask = 8
  For N = 1 To 4
    State = Nibble And Mask
    If State = 0 Then
      Pe_data = 0
    Else
      Pe_data = 1
    End If
    'Clock in data with rising edge
    Do1clock
    Shift Mask , Right
  Next N
  'Shift in 0-Bit
  Pe_data = 0
  Do1clock
  'Set E
  Pe_data = 1
  Waitus 50
  Pe_data = 0
  Waitus 50
End Sub

Sub Lcd_write_byte
  Low_nibble = Lcdbyte And 15
  High_nibble = Lcdbyte / 16
  Nibble = High_nibble
  Lcd_write_nibble
  Nibble = Low_nibble
  Lcd_write_nibble
End Sub

Sub Lcd_init
  Rs = 0                                                    'command mode
  Waitms 100                                                'Delay for power up time
  Nibble = &H03
  Lcd_write_nibble
  Waitms 1
  Nibble = &H03
  Lcd_write_nibble
  Waitms 1
  Nibble = &H03
  Lcd_write_nibble
  Waitms 1
  Nibble = &H02
  Lcd_write_nibble
  Waitms 1
  Lcdbyte = &H28
  Lcd_write_byte
  Waitms 1
  Lcdbyte = &H0C
  Lcd_write_byte
  Waitms 1
  Lcdbyte = &H01
  Lcd_write_byte
  Waitms 1
End Sub

Sub Lcd_pos
  Rs = 0                                                    'write CTRL
  Lcdbyte = 127 + Lcdpos
  If Lcdline = 2 Then Lcdbyte = Lcdbyte + 64
  If Lcdline = 3 Then Lcdbyte = Lcdbyte + 20
  If Lcdline = 4 Then Lcdbyte = Lcdbyte + 84
  Lcd_write_byte
End Sub

Sub Lcd_text
  Rs = 1                                                    'write Data
  J = Len(lcdtext)
  For I = 1 To J
    Char = Mid(lcdtext , I , 1 )
    Lcdbyte = Asc(char)
    Lcd_write_byte
  Next I
End Sub


' *********** RDS Erweiterung *************

Sub Init_rds()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H12
  I2cwbyte &H00
  I2cwbyte &H15
  I2cwbyte &H02
  I2cwbyte &H00
  I2cwbyte &H01
  I2cstop
End Sub


Sub Fm_rds_status()
  I2cstart
  I2cwbyte 34
  I2cwbyte &H24
  I2cwbyte &H00
  I2cstop
  I2cstart
  I2cwbyte 35
  I2crbyte Status , Ack
  I2crbyte R1 , Ack
  I2crbyte R2 , Ack
  I2crbyte R3 , Ack
  I2crbyte R4 , Ack
  I2crbyte R5 , Ack
  I2crbyte R6 , Ack
  I2crbyte R7 , Ack
  I2crbyte R8 , Ack
  I2crbyte R9 , Ack
  I2crbyte R10 , Ack
  I2crbyte R11 , Ack
  I2crbyte R12 , Ack
  I2crbyte R13 , Nack
  I2cstop
End Sub


Sub Rds()
  For Nr = 1 To 15
    Get_int_status
    If Status = 1 Then
      Fm_rds_status
      If R3 > 0 Then                                        'neue Daten?
        Bled = R12 And 3
        Service = R6 And 248
        If Service = 0 Then                                 '0A, Tuning Information
          If Bled = 0 Then
            Pos = R7 And 3
            Pos = Pos * 2
            Pos = Pos + 1
            Tx = Chr(r10)
            Tx = Tx + Chr(r11)
            Lcdpos = Pos : Lcdline = 2 : Lcd_pos
            Lcdtext = Tx : Lcd_text
          End If
        End If

        If Service = 32 Then                                '2A, Radiotext
          Pos = R7 And 15
          Pos = Pos * 4
          Pos = Pos + 1
          Lcdtext = Chr(r8)
          Lcdtext = Lcdtext + Chr(r9)
          Lcdtext = Lcdtext + Chr(r10)
          Lcdtext = Lcdtext + Chr(r11)
          If Pos < 20 Then
            Lcdpos = Pos : Lcdline = 3 : Lcd_pos
            Lcd_text
          Else
            Pos = Pos - 20
            Lcdpos = Pos : Lcdline = 4 : Lcd_pos
            If Pos < 18 Then Lcd_text
          End If
        End If


        If Service = 64 Then                                '4A, Time
          Utcoffset = R11 And 31
          Utcoffset = Utcoffset / 2
          Lo = R11 / 64
          Hi = R10 And 15
          Hi = Hi * 4
          Minuten = Hi + Lo
          Lo = R10 / 16
          Hi = R9 And 1
          Hi = Hi * 16
          Stunden = Hi + Lo
          If R11.5 = 1 Then
            Stunden = Stunden - Utcoffset
          Else
            Stunden = Stunden + Utcoffset
          End If
          Tx = Str(stunden)
          If Stunden < 10 Then
            Tx = "0" + Tx
          End If
          Lcdtext = Tx + ":"
          Tx = Str(minuten)
          If Minuten < 10 Then
            Tx = "0" + Tx
          End If
          Lcdpos = 9 : Lcdline = 2 : Lcd_pos
          Lcdtext = Lcdtext + Tx : Lcd_text
        End If
      End If
    End If
  Next Nr
End Sub





End